#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "baselistproxy4xi.py">
#<abstract4xi abstract = "provides types BaseListProxy and BaseListProxy4Xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>

# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'BaseListProxy4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                           
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import BaseListProxy
except:
    print("baselistproxy4xi.py *** failed in from multiprocessing.managers import BaseListProxy ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from baseproxy4xi import BaseProxy4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "MakeProxyType4Xi" usage = "
# embedded inside this module so that forkingpickler4xi detects this to be the module
#
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def MakeProxyType4Xi(name, exposed, cache={}):
    '''
    MakeProxyType4Xi function: returns an proxy type whose methods are given by `exposed`;
    
    '''
    class2print = "MakeProxyType4Xi"
    method2print = "MakeProxyType4Xi"
    
    message2print = "{started" + "; MakeProxyType4Xi-started: " + str(MakeProxyType4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)           
    
    message2print = "{passed" + "; name-passed-to-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    message2print = "{passed" + "; exposed-passed-to-MakeProxyType4Xi: " + str(exposed) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    message2print = "{passed" + "; cache-passed-to-MakeProxyType4Xi: " + str(cache) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   


    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    exposed2xi = tuple(exposed)
    
    message2print = "{set" + "; exposed2xi-set-by-MakeProxyType4Xi to: " + str(exposed2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
        
    try:
        message2print = "{passing" + "; name-passing-to-cache-by-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        message2print = "{passing" + "; exposed2xi-passing-to-cache-by-MakeProxyType4Xi: " + str(exposed2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{returning" + "; cache-returning-by-MakeProxyType4Xi: " + str(cache[(name, exposed2xi)]) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                
        
        return cache[(name, exposed2xi)]
    except KeyError:
        message2print = "{hit" + "; cache-exception-hit-by-MakeProxyType4Xi: "  + str(cache) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        

    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    dic2xi = {}
    message2print = "{looping" + "; exposed2xi-looping-by-MakeProxyType4Xi: "  + str(exposed2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
        
    for meth2xi in exposed2xi:
        exec('''def %s(self, *args, **kwds):
        return self._callmethod(%r, args, kwds)''' % (meth2xi, meth2xi), dic2xi)

    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
   
    ProxyType2Xi = type(name, (BaseProxy4Xi,), dic2xi)
    
    message2print = "{typed; ProxyType2Xi-typed-by-MakeProxyType4Xi to: " + str(ProxyType2Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    
    ProxyType2Xi._exposed_ = exposed2xi

    message2print = "{set; ProxyType2Xi-exposed-set-by-MakeProxyType4Xi to: " + str(ProxyType2Xi._exposed_)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
        
    cache[(name, exposed2xi)] = ProxyType2Xi
    
    message2print = "{set" + "; cache-set-by-MakeProxyType4Xi to: " + str(cache[(name, exposed2xi)])  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{returning" + "; ProxyType2Xi-returning-by-MakeProxyType4Xi: " + str(ProxyType2Xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    
    return ProxyType2Xi
#</function4xi> 

 

# -------------------------------------------------------------------------------------------------
# Types                              
#
#<type4xi type = "BaseListProxy4Xi" usage = "
#   managers.py: 
#       ListProxy(BaseListProxy): <--- type is used as the parameter
#           SyncManager.register('list', list, ListProxy) <--- defined for list
#   syncmanager4xi.py:
#       SyncManager4Xi.register('list', list, ListProxy4Xi)
#"
#>

#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
BaseListProxy4Xi = MakeProxyType4Xi('BaseListProxy4Xi', (
    '__add__', '__contains__', '__delitem__', '__delslice__',
    '__getitem__', '__len__', '__mul__',
    '__reversed__', '__rmul__', '__setitem__', 
    'append', 'count', 'extend', 'index', 'insert', 'pop', 'remove',
    'reverse', 'sort', '__imul__',
    'sense','reason','ace'))                  

#</type4xi>      
#</program4xi> 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of baselistproxy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
